﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WindowsFormsApplication1
{
    public partial class Form2 : Form
    {
        private int[] num;
        private int search;
        public Form2()
        {
            InitializeComponent();
            num = new int[0];
            search = -1;
        }
        public Form2(int[] num,int search)
        {
            InitializeComponent();
            this.num = num;
            this.search = search;
        }
        protected override void OnPaint(PaintEventArgs e)
        {
            Font font = new Font("Verdana",14);
            Font font_word = new Font("Verdana", 12);
            SolidBrush brush_check = new SolidBrush(Color.Red);
            SolidBrush brush = new SolidBrush(Color.Blue);
            SolidBrush brush2 = new SolidBrush(Color.Green);
            SolidBrush brush_word = new SolidBrush(Color.Black);
            Graphics g = e.Graphics;
            int top = 20;

            //初始左右二邊
            int left = 0;
            int right = num.Length-1;
            {
                
                int j = 1;
                top = 20;

                while(left<=right)//找不到時會成立
                {

                    g.DrawString("找第 " + (j ) + " 次", font_word, brush_word, 0, top);
                    j++;
                    
                    int mid = (left + right) / 2;//取中間點

                    if (num[mid] == search)
                    {
                        g.DrawString(num[mid].ToString(), font, brush_check, 30 * mid + 90, top);//找到
                        g.DrawString("找到了", font, brush_check, 30 * (mid + 1) + 90, top);//找到
                        return;
                    }
                    else
                    {
                        //中間值有可能在右邊或左邊
                        for (int i = left; i < mid + ((num[mid] < search) ? 1 : 0); i++)
                        {
                            g.DrawString(num[i].ToString(), font, brush, 30 * i + 90, top);
                        }
                        //中間值有可能在右邊或左邊
                        for (int i = right; i > mid-((num[mid] < search) ? 0 : 1); i--)
                        {
                            g.DrawString(num[i].ToString(), font, brush2, 30 * i + 90, top);
                        }
                        //一次切一半
                        if (num[mid]< search)
                        {

                            g.DrawString("左邊不要", font, brush, 30 * (right+1)+90 , top);
                            left = mid + 1;
                        }
                        else
                        {
                            g.DrawString("右邊不要", font, brush, 30 * (right + 1)+90, top);
                            right = mid - 1;
                        }
                    }
                    top = 20 * j;//印到下一行    
                }
            }
            g.DrawString("找不到", font, brush_check, 0, top+20);//找到
        }
       
    }
}
